<?php

class stack_cas_casstring {

    /** @var string as typed in by the user. */
    private $rawcasstring;

    /** @var string as modified by the validation. */
    private $casstring;

    /** @var bool if the string has passed validation. */
    private $valid;

    /** @var bool */
    private $key;

    /** @var string any error messages to display to the user. */
    private $errors;

    /**
     * @var string the value of the CAS string, in Maxima syntax. Only gets set
     *             after the casstring has been processed by the CAS.
     */
    private $value;

    /**
     * @var string how to display the CAS string, e.g. LaTeX. Only gets set
     *             after the casstring has been processed by the CAS.
     */
    private $display;

    /**
     * @var array Records logical informataion about the string, used for statistical
     *             anaysis of students' answers.
     */
    private $answernote;

    /**
     * @var string how to display the CAS string, e.g. LaTeX. Only gets set
     *              after the casstring has been processed by the CAS, and the
     *              CAS function is an answertest.
     */
    private $feedback;


    public function __construct($rawstring) {
        $this->rawcasstring   = $rawstring;



        $this->answernote = array();

        $this->valid          = true;  // If null then the validate command has not yet been run.無理やりtrueにした

        if (!is_string($this->rawcasstring)) {
            echo 'stack_cas_casstring: rawstring must be a string.';
        }

    }

    /*********************************************************/
    /* Return and modify information                         */
    /*********************************************************/

    public function get_casstring() {

        return $this->casstring;
    }

    public function get_key() {

        return $this->key;
    }

    public function get_value() {
        return $this->value;
    }

    public function get_display() {
        return $this->display;
    }

    public function set_key($key, $appendkey=true) {

		$this->key = $key;

    }

// 適当に作った関数
    public function set_casstring($casstring) {

		$this->casstring = $casstring;

    }

    public function set_value($val) {
        $this->value = $val;
    }

    public function set_display($val) {
        $this->display = $val;
    }

    public function get_answernote() {

        return implode(' | ', $this->answernote);
    }

    public function set_answernote($val) {
        $this->answernote[] = $val;
    }

    public function get_feedback() {
        return $this->feedback;
    }

    public function set_feedback($val) {
        $this->feedback = $val;
    }

    public function add_errors($err) {
        if ('' == trim($err)) {
            return false;
        } else {
            return $this->errors .= $err;
        }
    }


}
